game = {}
function game.update(dt)
		
-- Prüfe Kollisionen
-- Bewege Objekte und entferne Objekte
	local loeschObjekte = {}
	for k,v in ipairs(Spriteliste) do
		if v.dead then table.insert(loeschObjekte,k)
		else v:move(dt) end
	end
	table.sort(loeschObjekte, function (a,b) return (a > b) end)
	for i, v in ipairs(loeschObjekte) do table.remove(Spriteliste,v) end
	
-- Berechne Zeichenkoordinaten für Objekte
	for k,v in pairs(Spriteliste) do
		v:updateCoordinates()
	end
-- Sortiere nach "tiefe"	
	table.sort(Spriteliste, function (a,b) return (a.z < b.z) end)
	
	-- Setze Weltkoordinaten der Kamera
	camwx = player.wx
	camwy = player.wy
	camwz = camwz + 0.02*(camwzAim-camwz)

end

function game.draw()
	camx = 64 * (camwy-camwx)
	camy = 32 * (camwx+camwy) - 24*camwz

	love.graphics.push()
	love.graphics.translate(math.floor(400-camx),math.floor(300-camy))

	for x = 1,#map.tile do
		for y = 1,#map.tile[x] do
			drawTile(x,y)
			local spriteCount = #Spriteliste
			for i = 1,spriteCount do
				local currentSprite = Spriteliste[i]
				if math.floor(currentSprite.wx+currentSprite.radius)+1 == x and
				   math.floor(currentSprite.wy+currentSprite.radius)+1 == y then
				   currentSprite:draw()
				end
			end
		end
	end
	--[[local lastStripe = math.ceil(camy+300+24*mapMaxZ+133)/32
	currentZ = math.floor((camy-300)/32)
	for k,v in pairs(Spriteliste) do
		local newZ = math.min(math.floor(v.wx+v.radius)+math.floor(v.wy+v.radius)+2,lastStripe)
		if newZ > currentZ then
			for i = currentZ+1, newZ do
				if Stripes[i] then
					love.graphics.draw(Stripes[i],-64*#map.x,32*i-24*mapMaxZ-113)
				end
			end
			currentZ = newZ
		end
		v:draw()
	end
	for i = currentZ+1,lastStripe do
		if Stripes[i] then
			love.graphics.draw(Stripes[i],-64*#map.x,32*i-24*mapMaxZ-113)
		end
	end--]]
	
	love.graphics.pop()
	love.graphics.print('Framerate = ' .. love.timer.getFPS(),10,10)
end

function game.keypressed(key)
	if key == "escape" then
		love.event.push("quit")
	end	
	if key == "a" then
		player:hopp()
	end
	if key == "i" then
		local ball = Ball:New({wx = 3, wy = 3.5,wz = 4})
		table.insert(Spriteliste, ball)
	end
	local tileX = math.floor(player.wx)+1
	local tileY = math.floor(player.wy)+1
	if key == "w" and map.tile[math.floor(player.wx)+1] 
		and map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] then
		map.z[math.floor(player.wx)+1][math.floor(player.wy)+1] =
			math.min(map.z[math.floor(player.wx)+1][math.floor(player.wy)+1] + 1,mapMaxZ)
		map = calculateWallHeight(map)
	end
	if key == "s" and map.tile[math.floor(player.wx)+1] 
		and map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] then
		map.z[math.floor(player.wx)+1][math.floor(player.wy)+1] =
			math.max(map.z[math.floor(player.wx)+1][math.floor(player.wy)+1] - 1,0)
		map = calculateWallHeight(map)
	end
	if key == "e" and map.tile[math.floor(player.wx)+1] 
		and map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] then
		map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] =
			math.min(map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] + 1,19)
	end
	if key == "d" and map.tile[math.floor(player.wx)+1] 
		and map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] then
		map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] =
			math.max(map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] - 1,1)
	end
	if key == "m" then
		outputMap()
	end
	
end
