function drawTile(x,y)
	local xlength = #map.x
	local ylength = #map.x[1]
	love.graphics.drawq(kachelSet,kachelQuad[map.tile[x][y]],map.x[x][y]-64,map.y[x][y]-24*map.z[x][y]-113+24*mapMaxZ-240)	
	--love.graphics.draw(kachel[map.tile[x][y]],map.x[x][y]-64,map.y[x][y]-24*map.z[x][y]-113+24*mapMaxZ-240)	
	for k = 1,map.wallHeight[x][y] do
		love.graphics.draw(wand,map.x[x][y]-64,map.y[x][y]-24*(map.z[x][y]-k+1)+24*mapMaxZ-33-240)
	end
end

function outputMap()
print('Tiles')
for x in pairs(map.tile) do
	print('{')
	for y in pairs(map.tile[x]) do
		print(map.tile[x][y] .. ',')
	end
	print('}')
end

print('Z-Koordinaten')
for x in pairs(map.z) do
	print('{')
	for y in pairs(map.z[x]) do
		print(map.z[x][y] .. ',')
	end
	print('}')
end

end

function calculateWallHeight(map)
	map.wallHeight = {}
	for x = 1,#map.tile do
		map.wallHeight[x] = {}
		for y = 1,#map.tile[x] do
			local own = map.z[x][y]
			local right = map.z[x][y+1] or 0
			local left = 0
			local bottom = 0
			if map.z[x+1] then
				left = map.z[x+1][y] or 0
				bottom = map.z[x+1][y+1] or 0
			end
			map.wallHeight[x][y]= math.min(math.max(own-left,own-right), math.max(own-bottom+3,0))
		end
	end
	return map
end

function new_zmap(sizex,sizey)
	map = {}
	for x=1,sizex do
		map[x] = {}
		for y = 1,sizey do
			map[x][y] = math.max(0,math.random(1,1))
			if x == 1 or x == sizex or y == 1 or y == sizey then
				map[x][y] = 1
			end
		end
	end
	
	for zaehler = 1,2 do
		for x=2,sizex-1 do
			for y = 2,sizey-1 do
				map[x][y] = math.floor(0.25*(map[x+1][y]+map[x-1][y]+map[x][y+1]+map[x][y-1]))
			end
		end	
	end
	return map
end

function zmap_to_map(zmap)
	map.tile = {}
	map.z = {}
	map.y = {}
	map.x = {}
	for x =1,#zmap-1 do
		map.tile[x] = {}
		map.z[x] = {}
		map.y[x] = {}
		map.x[x] = {}
		for y = 1,#zmap[x]-1 do
			-- Bestimme Lokale Unterschiede
			local oben = 0
			local links = zmap[x+1][y]-zmap[x][y]
			local rechts = zmap[x][y+1]-zmap[x][y]
			local unten = zmap[x+1][y+1]-zmap[x][y]
			-- Berechnet tile.x, tile.y, tile.z ausgehend von der "unteren" Ecke
			map.x[x][y] = -64*x+64*y
			map.y[x][y] = 32*x+32*y
			map.z[x][y] = zmap[x+1][y+1]
			-- Komplizierte Case-unterscheidung zur bestimmung der Kachel
			if links == 0 and rechts == 0 and unten == 0 then map.tile[x][y] = 1
			elseif links == 0 and rechts == 0 and unten == 1 then map.tile[x][y] = 4 map.z[x][y] = map.z[x][y]-1
			elseif links == 0 and rechts == 0 and unten == -1 then map.tile[x][y] = 10
			elseif links == 0 and rechts == 1 and unten == 0 then map.tile[x][y] = 5
			elseif links == 0 and rechts == 1 and unten == 1 then map.tile[x][y] = 8 map.z[x][y] = map.z[x][y]-1
			elseif links == 0 and rechts == -1 and unten == -1 then map.tile[x][y] = 6
			elseif links == 0 and rechts == -1 and unten == 0 then map.tile[x][y] = 11 map.z[x][y] = map.z[x][y]-1

			elseif links == 1 and rechts == 0 and unten == 0 then map.tile[x][y] = 3
			elseif links == 1 and rechts == 1 and unten == 0 then map.tile[x][y] = 15
			elseif links == 1 and rechts == 1 and unten == 1 then map.tile[x][y] = 12 map.z[x][y] = map.z[x][y]-1 
			elseif links == 1 and rechts == 0 and unten == 1 then map.tile[x][y] = 9 map.z[x][y] = map.z[x][y]-1
			elseif links == 1 and rechts == -1 and unten == 0 then map.tile[x][y] = 17 map.z[x][y] = map.z[x][y]-1
			elseif links == 1 and rechts == 1 and unten == 2 then map.tile[x][y] = 18 map.z[x][y] = map.z[x][y]-2

			elseif links == -1 and rechts == 0 and unten == 0 then map.tile[x][y] = 13 map.z[x][y] = map.z[x][y]-1
			elseif links == -1 and rechts == 0 and unten == -1 then map.tile[x][y] = 7
			elseif links == -1 and rechts == -1 and unten == 0 then map.tile[x][y] = 14 map.z[x][y] = map.z[x][y]-1
			elseif links == -1 and rechts == -1 and unten == -1 then map.tile[x][y] = 2
			elseif links == -1 and rechts == 1 and unten == 0 then map.tile[x][y] = 16 map.z[x][y] = map.z[x][y]-1
			elseif links == -1 and rechts == -1 and unten == -2 then map.tile[x][y] = 19
			else map.tile[x][y] = 1
			end
		end
	end
	return map
end

function zFromMap(x,y)
	if x<=0 or y<=0 then return 0 end
	if x>= #map.x or y>=#map.x[1] then return 0 end
	truncX = math.floor(x)+1
	truncY = math.floor(y)+1
	x = x-truncX+1
	y = y-truncY+1
	if map.tile[truncX][truncY] == 1 then return map.z[truncX][truncY]
	elseif map.tile[truncX][truncY] == 2 then return map.z[truncX][truncY] + math.max(0,1-x-y)
	elseif map.tile[truncX][truncY] == 3 then return map.z[truncX][truncY] + math.max(0,x-y)
	elseif map.tile[truncX][truncY] == 4 then return map.z[truncX][truncY] + math.max(0,x+y-1)
	elseif map.tile[truncX][truncY] == 5 then return map.z[truncX][truncY] + math.max(0,y-x)
	elseif map.tile[truncX][truncY] == 6 then return map.z[truncX][truncY] + 1-y
	elseif map.tile[truncX][truncY] == 7 then return map.z[truncX][truncY] + 1-x
	elseif map.tile[truncX][truncY] == 8 then return map.z[truncX][truncY] + y
	elseif map.tile[truncX][truncY] == 9 then return map.z[truncX][truncY] + x
	elseif map.tile[truncX][truncY] == 10 then return map.z[truncX][truncY] + math.min(1,2-x-y)
	elseif map.tile[truncX][truncY] == 11 then return map.z[truncX][truncY] + math.min(1,x-y+1)
	elseif map.tile[truncX][truncY] == 12 then return map.z[truncX][truncY] + math.min(1,x+y)
	elseif map.tile[truncX][truncY] == 13 then return map.z[truncX][truncY] + math.min(1,y-x+1)
	elseif map.tile[truncX][truncY] == 14 then return map.z[truncX][truncY] + 1+ math.min(x-y,y-x)
	elseif map.tile[truncX][truncY] == 15 then return map.z[truncX][truncY] + math.min(x+y,2-x-y)
	elseif map.tile[truncX][truncY] == 16 then return map.z[truncX][truncY] - x+y + 1
	elseif map.tile[truncX][truncY] == 17 then return map.z[truncX][truncY] + x-y + 1
	elseif map.tile[truncX][truncY] == 18 then return map.z[truncX][truncY] + x+y
	elseif map.tile[truncX][truncY] == 19 then return map.z[truncX][truncY] - x-y + 2
	end
end

function zFromMapAndRadius(x,y,radius)
	-- Object close to grid line?
	local smallX = (x-math.floor(x) < radius)
	local smallY = (y-math.floor(y) < radius)
	local largeX = (math.floor(x)+1-x < radius)
	local largeY = (math.floor(y)+1-y < radius)
	if not smallX and not smallY and
		 not largeX and not largeY then
		return zFromMap(x,y)
	end
	-- Need maximum of possible points
	local z = zFromMap(x,y)
	if smallX then
		z = math.max(zFromMap(math.floor(x)-0.0001,y),z)
		if smallY then
			z = math.max(zFromMap(math.floor(x)-0.0001,math.floor(y)-0.0001),z)
		elseif largeY then
			z = math.max(zFromMap(math.floor(x)-0.0001,math.floor(y)+1),z)
		end
	end
	if smallY then
		z = math.max(zFromMap(x,math.floor(y)-0.0001),z)
	end
	if largeX then
		z = math.max(zFromMap(math.floor(x)+1,y),z)
		if smallY then
			z = math.max(zFromMap(math.floor(x)+1,math.floor(y)-0.0001),z)
		elseif largeY then
			z = math.max(zFromMap(math.floor(x)+1,math.floor(y)+1),z)
		end
	end
		
	if largeY then
		z = math.max(zFromMap(x,math.floor(y)+1),z)
	end
	return z
end

function gradientFromMap(x,y)
-- Gebe richtung der Steigung aus
-- Vektor zeigt immer Bergab
	if x<=0 or y<=0 then return {0,0} end
	if x>= #map.x or y>=#map.x[1] then return {0,0} end
	-- Ab hier ist truncXY die ganzzahlige Zelle und x,y die Koordinate in
	-- der Zelle (zwischen 0 und 1)
	truncX = math.floor(x)+1
	truncY = math.floor(y)+1
	x = x-truncX+1
	y = y-truncY+1
	local tileHere = map.tile[truncX][truncY]
	local zHere = map.z[truncX][truncY]
	-- eindeutige Fälle
	if tileHere == 1 then return {0,0}
	elseif tileHere ==  6 then return {0,1}
	elseif tileHere ==  7 then return {1,0}
	elseif tileHere ==  8 then return {0,-1}
	elseif tileHere ==  9 then return {-1,0}
	elseif tileHere == 16 then return {1,-1}
	elseif tileHere == 17 then return {-1,1}
	elseif tileHere == 18 then return {-1,-1}
	elseif tileHere == 19 then return {1,1}
	end
	
	if x+y < 1 then -- obere Hälfte
		if tileHere == 2 then return {1,1}
		elseif tileHere == 4 then return {0,0}
		elseif tileHere == 10 then return {0,0}
		elseif tileHere == 12 then return {-1,-1}
		elseif tileHere == 15 then return {-1,-1}
		end
	else -- untere Hälfte
		if tileHere == 2 then return {0,0}
		elseif tileHere == 4 then return {-1,-1}
		elseif tileHere == 10 then return {1,1}
		elseif tileHere == 12 then return {0,0}
		elseif tileHere == 15 then return {1,1}
		end
	end
	
	if x > y then -- linke Hälfte
		if tileHere == 3 then return {-1,1}
		elseif tileHere == 5 then return {0,0}
		elseif tileHere == 11 then return {0,0}
		elseif tileHere == 13 then return {1,-1}
		elseif tileHere == 14 then return {1,-1}
		end
	else -- rechte Hälfte
		if tileHere == 3 then return {0,0}
		elseif tileHere == 5 then return {1,-1}
		elseif tileHere == 11 then return {-1,1}
		elseif tileHere == 13 then return {0,0}
		elseif tileHere == 14 then return {-1,1}
		end
	end
	print('Fehler, keine Steigung gefunden')
	return {0,0}
end
